//+------------------------------------------------------------------+
//|                 Murrey Maths auto-trading EA by SteveHopwood.mq4 |
//|                                  Copyright  2010, Steve Hopwood |
//|                              http://www.hopwood3.freeserve.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Steve Hopwood"
#property link      "http://www.hopwood3.freeserve.co.uk"
#include <WinUser32.mqh>
#include <stdlib.mqh>

#define  NL    "\n"
#define  upperhedgeline "Upper hedge line"
#define  lowerhedgeline "Lower hedge line"
#define  gap  "                                "


//I have taken the code that displays the MM lines directly from this indicator.
//My grateful appreciation to the authour of the indi.
//+------------------------------------------------------------------+
//|                                           Murrey_Math_Line_X.mq4 |
//|                         Copyright  2004, Vladislav Goshkov (VG).|
//|                                                      4vg@mail.ru |
//|                                 code change by Alex.Piech.FinGeR |
//+------------------------------------------------------------------+
/*
bool IsBarClosed(int timeframe,bool reset)
void LookForTradingOpportunities()
void del_obj(string UniqueID)  
string FindLastVLine()
void DrawLines()
void GetCurrentMMlPosition()
bool DoesTradeExist(double lot)
bool SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double take)
void CountOpenTrades()
void TradeDirectionBySwap()
bool ShouldWinningPositionClose()
void LookForPendingDeletion()
void DeletePendingTrades()
void CloseAllTrades()
void MaintainGVs()
----Deal with losing trades
void HasMarketPassedExtreme()
bool HedgePosition()
void LookForFailedHedging()

*/

extern string  gi                      = "----General inputs----";
extern double  Lot1                    = 0.01;
extern double  Lot2                    = 0.02;
extern double  Lot3                    = 0.06;
extern double  Lot4                    = 0.12;    

extern string  tr                      = "----Trading----";
extern bool    TradeLong               = true;
extern bool    TradeShort              = true;


extern int     MaxTrades               = 3;           //Maximum recovery iterations eg 3= 1.2.6, 2=1.2
extern int     FirstTradeLine          = 3;           //0,1,2 or 3.The MML at which Lot1 trades are taken. Use in conjunction with MaxTrades
extern bool    CriminalIsECN           = false;       

string         UniqueID                = "MEDS_MML";  //Must be the same as the prefix of the lines drawn by the mml indy
extern int     MagicNumber             = 0;
extern string  TradeComment            = "pip";
extern bool    VisibleTP               = false;       //Send TP with order
extern bool    VisibleSL               = false;       //Set a stoploss of 1 mml for pending trades

extern string  tp                      = "----Take Basket Profits----";
extern bool    TakeProfitBasket        = false;       // If the basket hits the defined profit level then close all trades for this pair
extern int     TakeProfitPercentage    = 0;           // Zero means do not use this.Close basket based on percentage of account balance.
extern int     TakeProfitDollar        = 0;           // Zero means do not use this.Close basket based on hard dollar value
extern double  TargetAsPercentofOctave = 70;          // Percentage of MML for TP.

extern string  bf                      = "----Trading balance filters----";
extern bool    UseZeljko               = false;
extern bool    OnlyTradeCurrencyTwice  = true;

extern string  lto                     = "----Death trade options----";
extern bool    CloseLosingBasket       = false;
extern string  hed                     = "Hedging";
extern bool    UseHedging              = true;
extern double  HedgeLotMultiplier      = 1;
extern double  MMLSToHedgeLine         = 0;           //Distance from outer yellow lines to hedge line -ve means inside hedgeline
extern bool    CloseHedgeOnReturnToGrid= false;

extern string  amc                     = "----Available Margin checks----";
extern string  sco                     = "Scoobs";
extern bool    UseScoobsMarginCheck    = false;
extern string  fk                      = "ForexKiwi";
extern bool    UseForexKiwi            = false;
extern int     FkMinimumMarginPercent  = 1100;

extern string  pts                     = "----Swap filter----";
extern bool    CadPairsPositiveOnly    = false;
extern bool    AudPairsPositiveOnly    = false;
extern bool    NzdPairsPositiveOnly    = false;

extern string  ot                      = "----Other----";
extern bool    RemoveArrowsOnExit      = false;       
extern bool    Debug                   = false;       //Debug logging on/off
extern bool    Error                   = true;        //error logging on/off

///////////////////////////////////////////////////////////////////////////////////////////
//Indi variables
double         dmml = 0,
               mml[13],
               aLot[4];

string         ScreenMessage;
        
int            OctLinesCnt = 13,
               i = 0;
string         name = "", 
               lastname = "";
///////////////////////////////////////////////////////////////////////////////////////////

double         BandHigh, 
               BandLow;//Hi-lo of the market's MM Band

int            Band,
               OpenTrades;
double         BasketUpl;//For hedging
bool           ForceTradeClosure, 
               ForcePendingTradeDeletion;

//Trade ticket numbers etc
int            TradeTicketNo[5];//Will use 1 to 4
int            TicketNo;//Temp store for successful order-send ticket number
bool           BuyPending, SellPending;//Set to true if pendings are in place
double         LargestLot;

//Hedging
bool           BuyOpen, 
               SellOpen,
               HedgingInProgress;
double         OpenLots;
int            FilledBuys, 
               FilledSells;

//bool           Redraw;
string         gvName0;
string         gvName12;
string         gvBase;
//Matt's O-R stuff
int 	         O_R_Setting_max_retries 	= 1000;
double 	      O_R_Setting_sleep_time 		= 4.0; /* seconds */
double 	      O_R_Setting_sleep_max 		= 15.0; /* seconds */
double         stoplevel;
bool    UseLimitOrders          = true;       

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{

   double multiplier;
   if(Digits == 2 || Digits == 4) multiplier = 1;
   if(Digits == 3 || Digits == 5) multiplier = 10;
   if(Digits == 6) multiplier = 100;   
   if(Digits == 7) multiplier = 1000;   
   gvBase = Symbol()+ Period() + MagicNumber;
   gvName0  = gvBase + "mml0";
   gvName12 = gvBase + "mml12";
   
//---- indicators
   DrawLines();
//   if (MagicNumber == 9999) MagicNumber = Period();
   stoplevel = MarketInfo(Symbol(), MODE_STOPLEVEL) * Point;
   TradeComment = MagicNumber;
   aLot[0]    = Lot1;
   aLot[1]    = Lot2;
   aLot[2]    = Lot3;
   aLot[3]    = Lot4;
   IsBarClosed(-1,false);
//----
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
//----
   Comment(" ");   
   if(RemoveArrowsOnExit )del_obj("#");//
   return;//Don't want the lines deleted
   

//----
   return(0);
}
//+------------------------------------------------------------------+
//| check if new bar has formed
//|
//| if you don't want to execute on the first tick
//| IsBarClosed(-1,false);
//|
//|
//| check if bar is closed
//|if(!IsBarClosed(0,true)) // true/false here allows to keep old bar for check again later in the code and reset
//|    return(0);
//+------------------------------------------------------------------+
bool IsBarClosed(int timeframe,bool reset)
{
    static datetime lastbartime;
    if(timeframe==-1)
    {
        if(reset)
            lastbartime=0;
        else
            lastbartime=iTime(NULL,timeframe,0);
        return(true);
    }
    if(iTime(NULL,timeframe,0)==lastbartime) // wait for new bar
        return(false);
    if(reset)
        lastbartime=iTime(NULL,timeframe,0);
    return(true);
}//+-----------------------------------------------------------------+
void del_obj(string key)  {
//+------------------------------------------------------------------+
  int k=0;
  while (k<ObjectsTotal())   {
    string objname = ObjectName(k);
    if (StringSubstr(objname,0,StringLen(key)) == key)  
      ObjectDelete(objname);
    else
      k++;
  }//while (k<ObjectsTotal())      
  return(0);
}
//+------------------------------------------------------------------+
string FindLastVLine()  {
//+------------------------------------------------------------------+
  int k=0;
  datetime dt = 0;
  while (k<ObjectsTotal())   {
    string objname = ObjectName(k);
    
    if (StringSubstr(objname,0,StringLen(UniqueID + " Redraw")) == UniqueID + " Redraw")
    { 
if(Debug)Print("K=",k,",,ObjectsTotal=",ObjectsTotal(),",objname=",objname);
      if (dt < ObjectGet(objname , OBJPROP_TIME1))
      {
         dt = ObjectGet(objname , OBJPROP_TIME1);
if(Debug)Print("dt=", TimeToStr(dt,TIME_DATE|TIME_MINUTES));
      }
    }
    k++;
  }//while (k<ObjectsTotal())      
if(Debug)Print("dt=", TimeToStr(dt,TIME_DATE|TIME_MINUTES));
  return(TimeToStr(dt));
}  
//+------------------------------------------------------------------+
//| setGVs()                           |
//+------------------------------------------------------------------+
//void SetGVs()
//{
//   GlobalVariableSet(gvName0 ,mml[ 0]);
//   GlobalVariableSet(gvName12,mml[12]);        
//}
//+------------------------------------------------------------------+
//| DrawLines()                           |
//+------------------------------------------------------------------+
void DrawLines()
{   
if (Debug) Print( "Starting Drawlines"); 

   	name = FindLastVLine();   
if(Debug)Print("DrawLines1:-",name,",",lastname);
      for( i=0; i<OctLinesCnt; i++ )
      {
         string objname ="";
         objname = UniqueID + i + "-" + name;
         mml[i] = ObjectGet(objname,OBJPROP_PRICE1);
if(Debug)Print("DrawLines2:-name=",objname,",mml[",i,"]=",mml[i]);
      }

      dmml = mml[1]-mml[0];
      DrawHedgeLines();

}//End void DrawLines()

//+---------------------------------------------------------------------
void DrawHedgeLines()
{
   if(ObjectFind(upperhedgeline) == -1 )
   {
      ObjectCreate(upperhedgeline, OBJ_HLINE , 0,Time[0], NormalizeDouble(mml[12] + (dmml * MMLSToHedgeLine), Digits));
      ObjectSet(upperhedgeline, OBJPROP_STYLE, STYLE_DOT);
      ObjectSet(upperhedgeline, OBJPROP_COLOR, Red);
      ObjectSet(upperhedgeline, OBJPROP_WIDTH, 0);
   }
   else
   {
      ObjectMove(upperhedgeline,0,Time[0],NormalizeDouble(mml[12] +  (dmml * MMLSToHedgeLine), Digits)); 
   }   
   if(ObjectFind(lowerhedgeline) == -1 )
   {
      ObjectCreate(lowerhedgeline, OBJ_HLINE , 0,Time[0], NormalizeDouble(mml[0] -  (dmml * MMLSToHedgeLine), Digits));
      ObjectSet(lowerhedgeline, OBJPROP_STYLE, STYLE_DOT);
      ObjectSet(lowerhedgeline, OBJPROP_COLOR, Red);
      ObjectSet(lowerhedgeline, OBJPROP_WIDTH, 0);
   }
   else
   {
      ObjectMove(lowerhedgeline,0,Time[0],NormalizeDouble(mml[0] -  (dmml * MMLSToHedgeLine), Digits)); 
   }   
   
}

//+---------------------------------------------------------------------
void GetCurrentMMlPosition()
{   
   BandHigh = -1;
   BandLow = -1;
   Band = 1;
   
   //Calculates the hi-lo of the current band

   if(Bid < mml[0] || Bid > mml[12]) Band=-1;//Price is outside Yellow

   for (int cc = 0; cc <= OctLinesCnt-1; cc++)
   {  
if(Debug)Print("mml",cc,"=",mml[cc]);
      if (Bid >= mml[cc] && Bid <= mml[cc + 1] )
      {
         BandHigh = mml[cc + 1];
         BandLow = mml[cc];
         break;
      }//if (Bid >= mml[cc] && Bid <= mml[cc + 1] )
      Band++;
   }//for (int cc = 0; cc <= OctLinesCnt-1; cc++)
   

}//void GetCurrentMMlPosition()

bool DoesTradeExist(double lot=-1)
{
   //-1 is passed as the lot size to force a general find-any
   
   if (OrdersTotal() == 0) return(false);
   
   for (int cc = 0; cc <= OrdersTotal() - 1; cc++)
   {
      if (!OrderSelect(cc, SELECT_BY_POS) ) continue;
      if (OrderMagicNumber() != MagicNumber) continue;
      if (OrderCloseTime() > 0) continue;
      //-1 is passed as the lot size to force a general find-any   
      if (OrderSymbol() == Symbol() && (OrderLots() == lot || lot == -1)) return(true);   
   }//for (int cc = 0; cc <= OrdersTotal() - 1; cc++)
   
   return(false);
   
}//bool DoesTradeExist(double lot)


void DeletePendingTrades()
{
   ForcePendingTradeDeletion = false;
   
   for (int cc = OrdersTotal() - 1; cc >= 0; cc--)
   {
      if (!OrderSelect(cc, SELECT_BY_POS) ) continue;
      if (OrderMagicNumber() != MagicNumber) continue;
      if (OrderSymbol() != Symbol() ) continue;
      //if (OrderType() != OP_BUYLIMIT && OrderType() != OP_SELLLIMIT) continue;
      int tn = OrderTicket();
      while(IsTradeContextBusy()) Sleep(100);
      if (( OrderType() == OP_BUYLIMIT || OrderType() == OP_SELLLIMIT || 
            OrderType() == OP_BUYSTOP || OrderType() == OP_SELLSTOP ) && OrderCloseTime() == 0) 
      {
         bool result = OrderDelete(tn);      
         if (result) cc++;
         if (!result) ForcePendingTradeDeletion = true;//Force a retry at the next tick
      }//if (OrderType() == OP_BUYLIMIT || OrderType() == OP_SELLLIMIT) 
      
   }//for (int cc = OrdersTotal() - 1; cc >= 0; cc--)

}//End void DeletePendingTrades()

//+---------------------------------------------------------------------------------
double take, stop, price, lotsize;
int type, LastTradeLine;
double trigger;
bool Send;
//+---------------------------------------------------------------------------------
int LookForTradingOpportunities()
{  
   if (Band > 4 && Band < 9) return;
   //Balance filter
   if (Band < 5 && (UseZeljko && !BalancedPair(OP_BUY)   && FilledBuys  == 0)) return;
   if (Band > 8 && (UseZeljko && !BalancedPair(OP_SELL)  && FilledSells == 0)) return;

   //Only trade a currency twice
   if (OnlyTradeCurrencyTwice && OpenTrades == 0)
   {
      if (!IsThisPairTradable() ) return;
   }//if (OnlyTradeCurrencyTwice)

   Send = false;
   take= 0; stop =0; price = 0;
   //double target;
   int temp;
      
   //Long opportunities 
   temp = FirstTradeLine;
   LastTradeLine = temp - MaxTrades +1; 
if(Debug)Print("long opportunity1:FirstTradeLine=",FirstTradeLine,",LastTradeLine=",LastTradeLine,",temp=",temp );

   for (int m = temp; m>=LastTradeLine; m--)
   {
      trigger = NormalizeDouble(mml[m], Digits);
if(Debug)Print("long opportunity2:m=",m,",trigger=",trigger,",stoplevel",stoplevel,",Bid=", Bid,",trigger +  dmml=",trigger +  dmml );
      if (TradeLong && (Bid > (trigger + stoplevel ) && Bid < (trigger +  dmml*0.5))  && !DoesTradeExist(aLot[3-m]))
      {
         if(VisibleTP) take = NormalizeDouble(trigger + (dmml * TargetAsPercentofOctave /100 ), Digits);
         if(VisibleSL) stop = NormalizeDouble(trigger - dmml, Digits); // Paul addition for Sandovichtype = OP_BUYLIMIT;
if(Debug)Print("long opportunity3:trigger=",trigger );
         type = OP_BUYLIMIT;
         price = trigger;
         Send = true;
         lotsize = aLot[3-m];
         return(1);         
      }
   }
   //short opportunities
   temp = 12 - FirstTradeLine ;
   LastTradeLine = temp + MaxTrades - 1; 
if(Debug)Print("SHORT opportunity1:FirstTradeLine=",FirstTradeLine,",LastTradeLine=",LastTradeLine ,",temp=",temp );
   for ( m = temp; m<=LastTradeLine; m++)
   {
      trigger = NormalizeDouble(mml[m], Digits);
if(Debug)Print("short opportunityXXX:m=",m,",trigger=",trigger,",stoplevel",stoplevel,",Bid=", Bid,",trigger +  dmml=",trigger +  dmml );
      if (TradeShort && (Bid < (trigger - stoplevel)  && Bid > (trigger -  dmml*0.5))  && !DoesTradeExist(aLot[m-9]))
      {
         if(VisibleTP) take = NormalizeDouble(trigger - (dmml *TargetAsPercentofOctave /100), Digits);
         if (VisibleSL) stop = NormalizeDouble(trigger+dmml, Digits); // Paul addition for Sandovich
if (Debug)Print("short opportunity3:trigger=",trigger );
         type = OP_SELLLIMIT;
         price = trigger;
         Send = true;
         lotsize = aLot[m-9];
         return(-1); 
      }
   }  

   return(0);
}//int LookForTradingOpportunities()


void SendTrade(int type, double price, double lotsize,double take,double stop)
{

     //Neutralise the tp if necessary   
      bool result = SendSingleTrade(type, TradeComment, lotsize, price, stop, take);
      // else result = SendSingleTrade(type, TradeComment, lotsize, price, 0, take);      
if(Debug)Print("Band: ", Band, " Lot: ", lotsize, " Price: ", price, " mml ", mml[Band]);

      if (result) 
      {
//         ForceTradeClosure = false;//Thrashing around a bit here
         OrderSelect(TicketNo, SELECT_BY_TICKET);
         if (type == OP_BUYLIMIT)
         {
            if (OrderLots() == aLot[0]) TradeTicketNo[1] = TicketNo;
            if (OrderLots() == aLot[1]) TradeTicketNo[2] = TicketNo;
            if (OrderLots() == aLot[2]) TradeTicketNo[3] = TicketNo;
            if (OrderLots() == aLot[3]) TradeTicketNo[4] = TicketNo;         
         }//if (type == OP_BUYLIMIT)
         
         if (type == OP_SELLLIMIT)
         {
            if (OrderLots() == aLot[0]) TradeTicketNo[1] = TicketNo;
            if (OrderLots() == aLot[1]) TradeTicketNo[2] = TicketNo;
            if (OrderLots() == aLot[2]) TradeTicketNo[3] = TicketNo;            
            if (OrderLots() == aLot[3]) TradeTicketNo[4] = TicketNo;         
         }//if (type == OP_SELLLIMIT)
         
         
      }//if (result) 
      
}//void SendTrade()

bool SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double take)
{
   

   int slippage = 10;
   int err;
   if (Digits == 3 || Digits == 5) slippage = 100;
   
   color col = Red;
   if (type == OP_BUY || type == OP_BUYLIMIT) col = Green;
   
   int expiry = 0;
   //if (SendPendingTrades) expiry = TimeCurrent() + (PendingExpiryMinutes * 60);

   if (!CriminalIsECN) int ticket = OrderSend(Symbol(),type, lotsize, price, slippage, stop, take, comment, MagicNumber, expiry, col);
   

   

   //Is a 2 stage criminal
   if (CriminalIsECN)
   {
      bool result;
      
      ticket = OrderSend(Symbol(),type, lotsize, price, slippage, 0, 0, comment, MagicNumber, expiry, col);
      if (ticket > 0)
      {
	     
	     if (take > 0 && stop > 0)
        {
           while(IsTradeContextBusy()) Sleep(100);
           result = OrderModify(ticket, OrderOpenPrice(), stop, take, OrderExpiration(), CLR_NONE);
           if (!result)
           {
               err=GetLastError();
               if(Error)Print(Symbol(), " SL/TP  order modify failed with error(",err,"): ",ErrorDescription(err));               
           }//if (!result)			  
        }//if (take > 0 && stop > 0)
      
	     if (take != 0 && stop == 0)
        {
           while(IsTradeContextBusy()) Sleep(100);
           result = OrderModify(ticket, OrderOpenPrice(), OrderStopLoss(), take, OrderExpiration(), CLR_NONE);
           if (!result)
           {
               err=GetLastError();
               if(Error)Print(Symbol(), " SL  order modify failed with error(",err,"): ",ErrorDescription(err));               
           }//if (!result)			  
        }//if (take == 0 && stop != 0)

        if (take == 0 && stop != 0)
        {
           while(IsTradeContextBusy()) Sleep(100);
           result = OrderModify(ticket, OrderOpenPrice(), stop, OrderTakeProfit(), OrderExpiration(), CLR_NONE);
           if (!result)
           {
               err=GetLastError();
               if(Error)Print(Symbol(), " SL  order modify failed with error(",err,"): ",ErrorDescription(err));               
           }//if (!result)			  
        }//if (take == 0 && stop != 0)

      }//if (ticket > 0)
        
      
      
   }//if (CriminalIsECN)

   
   //Error trapping for both
   if (ticket < 0)
   {
      string stype;
      if (type == OP_BUY) stype = "OP_BUY";
      if (type == OP_SELL) stype = "OP_SELL";
      if (type == OP_BUYLIMIT) stype = "OP_BUYLIMIT";
      if (type == OP_SELLLIMIT) stype = "OP_SELLLIMIT";
      if (type == OP_BUYSTOP) stype = "OP_BUYSTOP";
      if (type == OP_SELLSTOP) stype = "OP_SELLSTOP";
      err=GetLastError();
//      Alert(Symbol(), " ", stype," order send failed with error(",err,"): ",ErrorDescription(err) );
if(Error)Print(Symbol(), " ", stype," order send failed with error(",err,"): ",ErrorDescription(err));
      return(false);
   }//if (ticket < 0)  
   
   
   TicketNo = ticket;
   //Make sure the trade has appeared in the platform's history to avoid duplicate trades
   O_R_CheckForHistory(ticket); 
   
   
   //Got this far, so trade send succeeded
   return(true);
   
}//End bool SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double take)

//=============================================================================
//                           O_R_CheckForHistory()
//
//  This function is to work around a very annoying and dangerous bug in MT4:
//      immediately after you send a trade, the trade may NOT show up in the
//      order history, even though it exists according to ticket number.
//      As a result, EA's which count history to check for trade entries
//      may give many multiple entries, possibly blowing your account!
//
//  This function will take a ticket number and loop until
//  it is seen in the history.
//
//  RETURN VALUE:
//     TRUE if successful, FALSE otherwise
//
//
//  FEATURES:
//     * Re-trying under some error conditions, sleeping a random
//       time defined by an exponential probability distribution.
//
//     * Displays various error messages on the log for Debugging.
//
//  ORIGINAL AUTHOR AND DATE:
//     Matt Kennel, 2010
//
//=============================================================================
bool O_R_CheckForHistory(int ticket)
{
   //My thanks to Matt for this code. He also has the undying gratitude of all users of my trading robots
   
   int lastTicket = OrderTicket();

   int cnt = 0;
   int err = GetLastError(); // so we clear the global variable.
   err = 0;
   bool exit_loop = false;
   bool success=false;

   while (!exit_loop) {
      /* loop through open trades */
      int total=OrdersTotal();
      for(int c = 0; c < total; c++) {
         if(OrderSelect(c,SELECT_BY_POS,MODE_TRADES) == true) {
            if (OrderTicket() == ticket) {
               success = true;
               exit_loop = true;
            }
         }
      }
      if (cnt > 3) {
         /* look through history too, as order may have opened and closed immediately */
         total=OrdersHistoryTotal();
         for(c = 0; c < total; c++) {
            if(OrderSelect(c,SELECT_BY_POS,MODE_HISTORY) == true) {
               if (OrderTicket() == ticket) {
                  success = true;
                  exit_loop = true;
               }
            }
         }
      }

      cnt = cnt+1;
      if (cnt > O_R_Setting_max_retries) {
         exit_loop = true;
      }
      if (!(success || exit_loop)) {
if(Error)Print("Did not find #"+ticket+" in history, sleeping, then doing retry #"+cnt);
         O_R_Sleep(O_R_Setting_sleep_time, O_R_Setting_sleep_max);
      }
   }
   // Select back the prior ticket num in case caller was using it.
   if (lastTicket >= 0) {
      OrderSelect(lastTicket, SELECT_BY_TICKET, MODE_TRADES);
   }
   if (!success) {
if(Debug)Print("Never found #"+ticket+" in history! crap!");
   }
   return(success);
}//End bool O_R_CheckForHistory(int ticket)

//=============================================================================
//                              O_R_Sleep()
//
//  This sleeps a random amount of time defined by an exponential
//  probability distribution. The mean time, in Seconds is given
//  in 'mean_time'.
//  This returns immediately if we are backtesting
//  and does not sleep.
//
//=============================================================================
void O_R_Sleep(double mean_time, double max_time)
{
   if (IsTesting()) {
      return;   // return immediately if backtesting.
   }

   double p = (MathRand()+1) / 32768.0;
   double t = -MathLog(p)*mean_time;
   t = MathMin(t,max_time);
   int ms = t*1000;
   if (ms < 10) {
      ms=10;
   }
   Sleep(ms);
}//End void O_R_Sleep(double mean_time, double max_time)

void CountOpenTrades()
{ 
   BuyOpen = false;
   SellOpen = false;   
   OpenTrades = 0;
   BasketUpl = 0;
   OpenLots = 0;
   ArrayInitialize(TradeTicketNo, -1);
   BuyPending = false;
   SellPending = false;
   double target;
   LargestLot = 0;
   FilledBuys = 0;
   FilledSells = 0;
   HedgingInProgress = false;
   static double HedgingProfit;
   if (OrdersTotal() == 0) return;

   int ot = OrdersTotal() - 1;
if(Debug)Print("OpenTrades: OrdersTotal()=",ot,",OrderSymbol()=",OrderSymbol(),",Symbol()=",Symbol());         
   
   for (int cc = 0; cc <= ot; cc++)
   {
      if (!OrderSelect(cc, SELECT_BY_POS) ) continue;
      if (OrderMagicNumber() != MagicNumber) continue;     
      if (OrderSymbol() == Symbol())
      {
if(Debug)Print("OpenTrades0, cc=",cc,",OrdersTotal()=",ot,",OrderSymbol()=",OrderSymbol(),",Symbol()=",Symbol());  
         if (OrderComment() == "H") HedgingProfit = OrderProfit() + OrderSwap() + OrderCommission();
         BasketUpl+= (OrderProfit() + OrderSwap() + OrderCommission());

if(Debug)Print("OpenTrades1, cc=",cc,",OrderType()=",OrderType());
         if (OrderType() == OP_BUYLIMIT  ) BuyPending = true; //continue;
         if (OrderType() == OP_SELLLIMIT ) SellPending = true; //continue;
         if (OrderType() == OP_BUY) {OpenLots+= OrderLots(); FilledBuys++; BuyOpen = true;}
         if (OrderType() == OP_SELL) {OpenLots+= OrderLots(); FilledSells++; SellOpen = true;}
         //Set up ticket numbers
if(Debug)Print("OpenTrades2, cc=",cc,",BasketUpl=",BasketUpl,",typ=",OrderType(),",Symbol()=",Symbol());
         for (int m =0;m<=3;m++)
         {
            if (OrderLots() == aLot[m] && (FilledBuys > 0 || FilledSells > 0) ) TradeTicketNo[m+1] = OrderTicket();
if(Debug)Print("OpenTrades3, m=",m,",aLot[m]=",aLot[m],",TradeTicketNo[m+1]=",TradeTicketNo[m+1],",Symbol()=",Symbol());
         }         
         
         if (OrderLots() > LargestLot) LargestLot = OrderLots();    
         if(FilledBuys > 0 || FilledSells > 0) OpenTrades++;
      }//if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
   }//for (int cc = OrdersTotal() - 1; cc <= 0; cc--)

   if (BuyOpen && SellOpen) HedgingInProgress = true;
}//End void CountOpenTrades()


void CloseAllTrades()
{
   ForceTradeClosure = false;
   
   if (OrdersTotal() == 0) return;
   
   for (int cc = OrdersTotal() - 1; cc >= 0; cc--)
   {
      if (!OrderSelect(cc, SELECT_BY_POS) ) continue;
      if (OrderMagicNumber() != MagicNumber) continue;
      if (OrderType() != OP_BUY && OrderType() != OP_SELL) continue;
      if (OrderSymbol() == Symbol() )
      {
         while(IsTradeContextBusy()) Sleep(100);
         bool result = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 1000, Blue);
         if (result) cc++;
         if (!result) ForceTradeClosure = true;
      }//if (OrderSymbol() == Symbol() )
   
   }//for (int cc = OrdersTotal() - 1; cc >= 0; cc--)


}//End void CloseAllTrades()

///////////////////////////////////////////////////////////////////////////////////////////////////////
//Balance/swap filters module
void TradeDirectionBySwap()
{

   //Sets TradeLong & TradeShort according to the positive/negative swap it attracts

   double LongSwap = MarketInfo(Symbol(), MODE_SWAPLONG);
   double ShortSwap = MarketInfo(Symbol(), MODE_SWAPSHORT);
   

   if (CadPairsPositiveOnly)
   {
      if (StringSubstr(Symbol(), 0, 3) == "CAD" || StringSubstr(Symbol(), 0, 3) == "cad" || StringSubstr(Symbol(), 3, 3) == "CAD" || StringSubstr(Symbol(), 3, 3) == "cad" )      
      {
         if (LongSwap > 0) TradeLong = true;
         else TradeLong = false;
         if (ShortSwap > 0) TradeShort = true;
         else TradeShort = false;         
      }//if (StringSubstr(Symbol(), 0, 3) == "CAD" || StringSubstr(Symbol(), 0, 3) == "cad" )      
   }//if (CadPairsPositiveOnly)
   
   if (AudPairsPositiveOnly)
   {
      if (StringSubstr(Symbol(), 0, 3) == "AUD" || StringSubstr(Symbol(), 0, 3) == "aud" || StringSubstr(Symbol(), 3, 3) == "AUD" || StringSubstr(Symbol(), 3, 3) == "aud" )      
      {
         if (LongSwap > 0) TradeLong = true;
         else TradeLong = false;
         if (ShortSwap > 0) TradeShort = true;
         else TradeShort = false;         
      }//if (StringSubstr(Symbol(), 0, 3) == "AUD" || StringSubstr(Symbol(), 0, 3) == "aud" || StringSubstr(Symbol(), 3, 3) == "AUD" || StringSubstr(Symbol(), 3, 3) == "aud" )      
   }//if (AudPairsPositiveOnly)
   
   
   if (NzdPairsPositiveOnly)
   {
      if (StringSubstr(Symbol(), 0, 3) == "NZD" || StringSubstr(Symbol(), 0, 3) == "nzd" || StringSubstr(Symbol(), 3, 3) == "NZD" || StringSubstr(Symbol(), 3, 3) == "nzd" )      
      {
         if (LongSwap > 0) TradeLong = true;
         else TradeLong = false;
         if (ShortSwap > 0) TradeShort = true;
         else TradeShort = false;         
      }//if (StringSubstr(Symbol(), 0, 3) == "AUD" || StringSubstr(Symbol(), 0, 3) == "aud" || StringSubstr(Symbol(), 3, 3) == "AUD" || StringSubstr(Symbol(), 3, 3) == "aud" )      
   }//if (AudPairsPositiveOnly)
   
   

}//void TradeDirectionBySwap()

bool IsThisPairTradable()
{
   //Checks to see if either of the currencies in the pair is already being traded twice.
   //If not, then return true to show that the pair can be traded, else return false
   
   string c1 = StringSubstr(Symbol(), 0, 3);//First currency in the pair
   string c2 = StringSubstr(Symbol(), 3, 3);//Second currency in the pair
   int c1open = 0, c2open = 0;
   //CanTradeThisPair = true;
   for (int cc = OrdersTotal() - 1; cc >= 0; cc--)
   {
      if (!OrderSelect(cc, SELECT_BY_POS) ) continue;
      /////////////////////////////////////////////////////////////////////////////////////////////////
      //if (OrderSymbol() != Symbol() ) continue;
      //The previous like looks like a logic error,as it means the code will not check the trade unless it
      //has the same symbol as the calling chart. If the trade has the same symbol as the calling chart, then
      //the check is not needed.
      /////////////////////////////////////////////////////////////////////////////////////////////////
      if(OrderType() == OP_BUY || OrderType() == OP_SELL)
      {
         int index = StringFind(OrderSymbol(), c1);
         if (index > -1)
         {
            c1open++;         
         }//if (index > -1)
   
         index = StringFind(OrderSymbol(), c2);
         if (index > -1)
         {
            c2open++;         
         }//if (index > -1)
   
//MED         if (c1open == 1 && c2open == 1)
         if (c1open == 2 || c2open == 2)  
         {
            //CanTradeThisPair = false;
            return(false);   
         }//if (c1open == 1 && c2open == 1)
      }//if(OrderType() == OP_BUY || OrderType() == OP_SELL) 
   }//for (int cc = OrdersTotal() - 1; cc >= 0; cc--)

   //Got this far, so ok to trade
   return(true);
   
}//End bool IsThisPairTradable()

bool BalancedPair(int type)
{

   //Only allow an individual currency to trade if it is a balanced trade
   //e.g. UJ Buy open, so only allow Sell xxxJPY.
   //The passed parameter is the proposed trade, so an existing one must balance that

   //This code courtesy of Zeljko (zkucera) who has my grateful appreciation.
   string BuyCcy1, SellCcy1, BuyCcy2, SellCcy2;

   if (type == OP_BUY)
   {
      BuyCcy1 = StringSubstr(Symbol(), 0, 3);
      SellCcy1 = StringSubstr(Symbol(), 3, 3);
   }//if (type == OP_BUY || type == OP_BUYSTOP)
   else
   {
      if (type == OP_SELL)
      {
         BuyCcy1 = StringSubstr(Symbol(), 3, 3);
         SellCcy1 = StringSubstr(Symbol(), 0, 3);
      }//if (type == OP_SELL)
   }//else   


   for (int cc = OrdersTotal() - 1; cc >= 0; cc--)
   {
      if (!OrderSelect(cc, SELECT_BY_POS)) continue;
      if (OrderSymbol() == Symbol()) continue;
      if (OrderMagicNumber() != MagicNumber) continue;      

      if (OrderType() == OP_BUY)
      {
         BuyCcy2 = StringSubstr(OrderSymbol(), 0, 3);
         SellCcy2 = StringSubstr(OrderSymbol(), 3, 3);
      }//if (OrderType() == OP_BUY || OrderType() == OP_BUYSTOP)
      else
      {
         if (OrderType() == OP_SELL)
         {
            BuyCcy2 = StringSubstr(OrderSymbol(), 3, 3);
            SellCcy2 = StringSubstr(OrderSymbol(), 0, 3);
         }//if (OrderType() == OP_SELL)
      }//else
      if (BuyCcy1 == BuyCcy2 || SellCcy1 == SellCcy2) return(false);
   }//for (int cc = OrdersTotal() - 1; cc >= 0; cc--)

   //Got this far, so it is ok to send the trade
   return(true);

}//End bool BalancedPair(int type)



//End Balance/swap filters module
///////////////////////////////////////////////////////////////////////////////////////////////////////

bool ShouldWinningPositionClose()
{
   //Returns true if position should close, else returns false
if(Debug)Print("Starting ShouldWinningPositionClose()");
   double target;
   RefreshRates();


  //Long trades. Closing at Bid captures the spread - result of research by Droland. Cheers Dave   
   for (int m=1;m<=4;m++)
   {
if(Debug)Print ("TradeTicketNo[m]=",TradeTicketNo[m],",m=",m,",Target=",target,",Bid=",Bid);
      if (OrderSelect(TradeTicketNo[m], SELECT_BY_TICKET) > -1 && OrderType() == OP_BUY && OrderProfit() > 0)
      {

         target = mml[4-m] + (  TargetAsPercentofOctave * dmml / 100);
if(Debug)Print ("Band=",Band,",Target=",target,",Bid=",Bid);
         if (Bid >= target) return(true);
      }//if (OrderSelect(TradeTicketNo[1], SELECT_BY_TICKET) > -1 && OrderType() == OP_BUY && OrderProfit() > 0)  
   }//for (m=1;m<=4;m++)   

   //Short trades Closing at Ask captures the spread - result of research by Droland. Cheers Dave
   for (m=1;m<=4;m++)
   {
if(Debug)Print ("TradeTicketNo[m]=",TradeTicketNo[m],",m=",m,",Target=",target,",Bid=",Bid);
      if (OrderSelect(TradeTicketNo[m], SELECT_BY_TICKET) > -1 && OrderType() == OP_SELL && OrderProfit() > 0)
      {
         target = mml[m+8] - (TargetAsPercentofOctave *dmml/100);
if(Debug)Print ("Band=",Band,",Target=",target,",Bid=",Bid);
         if (Ask <= target) return(true);
      }//if (OrderSelect(TradeTicketNo[m], SELECT_BY_TICKET) > -1 && OrderType() == OP_SELL && OrderProfit() > 0)
   }//for (m=1;m<=4;m++)



  if (Band > 4 && Band < 9 && BasketUpl > 0) return(true);
   

   //Got this far, so position should remain open
   return(false);

}//End bool ShouldWinningPositionClose()

bool HasMarketPassedExtreme()
{
   //Returns true if the basket has hit the outermost Death line.
   //Only called if CloseLosingBasket/UseHedging is chosen by the user
   
   double target = ObjectGet(upperhedgeline, OBJPROP_PRICE1);

   RefreshRates();
   if (Bid > target) return(true);
   target = ObjectGet(lowerhedgeline, OBJPROP_PRICE1);
   if (Bid < target) return(true);
   
   return(false);
   
}//bool HasMarketPassedExtreme()

void HedgePosition()
{
   //Called if a position needs hedging.
   
   double SendLots = OpenLots * HedgeLotMultiplier;
   int type;
   double price;
   TradeComment = "H";
   RefreshRates();
   if (BuyOpen) 
   {
      type = OP_SELL;
      price = Bid;
   }//if (BuyOpen) 
   
   if (SellOpen) 
   {
      type = OP_BUY;
      price = Ask;
   }//if (SellOpen) 
   
   
   bool result = SendSingleTrade(type, TradeComment, SendLots, price, 0, 0);
   if (result) HedgingInProgress = true;
   TradeComment = MagicNumber;
}//End void HedgePosition()

void LookForFailedHedging()
{
   //Close an open hedge trade if the market has moved back inside the hedge lines
   
   double high = NormalizeDouble(mml[12] + (dmml * MMLSToHedgeLine) , Digits);
   double low  = NormalizeDouble(mml[0]  - (dmml * MMLSToHedgeLine) , Digits);
   
   int cc;
   if (Bid < high && Bid > low)
   {
      //Hedge easily recognised as a sell trade. There will be more filled buys than sells.
      if (FilledBuys > FilledSells)
      {
         for (cc = OrdersTotal() - 1; cc >= 0; cc--)
         {
            if (!OrderSelect(cc, SELECT_BY_POS) ) continue;
            if (OrderMagicNumber() != OrderMagicNumber() ) continue;
            if (OrderSymbol() != Symbol() ) continue;
            if (OrderType() == OP_SELL) 
            {
               while (IsTradeContextBusy() ) Sleep(100);
               bool result = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 10000, Blue);
               if (!result) Alert("Order close fail");
               return;
            }//if (OrderType() == OP_SELL) 
            
         }//for (cc = OrdersTotal() - 1; cc >= 0; cc--)         
      }//if (FilledBuys > FilledSells)
      
      //Hedge easily recognised as a buy trade. There will be more filled sells than buys.
      if (FilledBuys < FilledSells)
      {
         for (cc = OrdersTotal() - 1; cc >= 0; cc--)
         {
            if (!OrderSelect(cc, SELECT_BY_POS) ) continue;
            if (OrderMagicNumber() != OrderMagicNumber() ) continue;
            if (OrderSymbol() != Symbol() ) continue;
            if (OrderType() == OP_BUY) 
            {
               while (IsTradeContextBusy() ) Sleep(100);
               result = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 10000, Blue);
               if (!result) Alert("Order close fail");
               return;
            }//if (OrderType() == OP_SELL) 
            
         }//for (cc = OrdersTotal() - 1; cc >= 0; cc--)         
      }//if (FilledBuys > FilledSells)
      
   
   }//if (Bid < high && Bid > low)
   

}//void LookForFailedHedging()


//+------------------------------------------------------------------+
//| LookForPendingDeletion                                            |
//+------------------------------------------------------------------+
void LookForPendingDeletion()
{
   //Unfilled pandings can need deleting for a variety of reasons
   
   bool Delete = false;
if(Debug)Print("BuyPending/SellPending=",BuyPending,",", SellPending);  

   if (Band > 4  && Band < 9  && UseLimitOrders && (BuyPending || SellPending) )
   {
      Delete = true;
   }//if (Band > 4 && Band < 9 && (PendingBuy || PendingSell)


   if (mml[0] != GlobalVariableGet(gvName0) || mml[12] != GlobalVariableGet(gvName12))
   {
      Delete = true;
      GlobalVariableSet(gvName0,mml[0]);
      GlobalVariableSet(gvName12,mml[12]);
   }   
   
   //Balanced pairs
   if (UseZeljko)
   {
      if (BuyPending && !BalancedPair(OP_BUY) ) Delete = true;
      if (SellPending && !BalancedPair(OP_SELL) ) Delete = true;   
   }//if (UseZeljko)
   
   //Only trade a currency twice
   if (OnlyTradeCurrencyTwice && OpenTrades == 0)
   {
      if (!IsThisPairTradable() ) Delete = true;      
   }//if (OnlyTradeCurrencyTwice)

   
   if (Delete) DeletePendingTrades();

}//End void LookForPendingDeletion()


//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   int start = GetTickCount( );
   CountOpenTrades();
   if (OpenTrades == 0)
   {
      ForceTradeClosure = false;
      ForcePendingTradeDeletion = false;
      HedgingInProgress = false;
   }//if (OpenTrades == 0)

   //Deal with a trade closure failnre
   if (ForceTradeClosure)
   {
      CloseAllTrades();
      return;
   }//if (ForceTradeClosure)
   

   if (ForcePendingTradeDeletion)
   {
      DeletePendingTrades();
      return;
   }//if (ForcePendingTradeDeletion)
   
      
   DrawLines();//Also set up mml[] array values
   
   GetCurrentMMlPosition();
   
   
   ScreenMessage = StringConcatenate(gap, TimeToStr(TimeLocal(), TIME_DATE|TIME_MINUTES|TIME_SECONDS), NL,
                                     gap, "Band high: ", DoubleToStr(BandHigh, Digits), NL,
                                     gap, "Band low: ", DoubleToStr(BandLow, Digits), NL,
                                     gap, "Band no: ", Band, NL,
                                     gap, "DMML: ", DoubleToStr(dmml, Digits), NL,
                                     gap, "Stoplevel: ", DoubleToStr(stoplevel, Digits), NL);
   
   Comment(ScreenMessage);
 
   /////////////////////////////////////////////////////////////////////////////////////////////////////////      
   //Position closure 
   if (OpenTrades > 0 && BasketUpl > 0)
   {
if(Debug)Print("OpenTrades=",OpenTrades);
      double TPValue = 0;
      if (TakeProfitBasket) 
      {
         if (TakeProfitPercentage != 0 && TakeProfitDollar != 0) Alert("Both TakeProfitPercentage and TakeProfitDollar are set, I do not think you meant to do that??!!");
         if (TakeProfitPercentage == 0 && TakeProfitDollar == 0) Alert("TakeProfitBasket is true, but both TakeProfitPercentage and TakeProfitDollar are NOT set! One of these parameters needs to be greater than zero!");
         if (TakeProfitDollar > 0 ) TPValue=TakeProfitDollar;
         if (TakeProfitPercentage > 0) TPValue = AccountBalance()*(TakeProfitPercentage/100);    
      } // if (TakeProfiBasket)
      
      if (ShouldWinningPositionClose() || (TakeProfitBasket && BasketUpl >= TPValue) )
      {
         CloseAllTrades();
         return;
      }//if (ShouldWinningPositionClose() )      
   }//if (OPenTrades > 0 && OPenTrades < 4)
  
   if (OpenTrades > 0 && CloseLosingBasket)
   {
      if (HasMarketPassedExtreme() )
      {
         CloseAllTrades();
         return;
      }//if (HasMarketPassedExtreme() )   
   }//if (OpenTrades > 0 && CloseLosingBasket)

   //Successful hedging
   if (HedgingInProgress && BasketUpl > 0) 
   {
      CloseAllTrades();
      return;
   }//if (HedgingInProgress && BasketUpl > 0)
  
   //Failed hedging
   if (HedgingInProgress && BasketUpl < 0 && CloseHedgeOnReturnToGrid)
   {
      LookForFailedHedging();
   }//if (HedgingInProgres && BasketUpl < 0)
   
   
   //Delete pending trades for a variety of reasons
//   if (DeleteUnwantedPendings) LookForPendingDeletion();
   LookForPendingDeletion();
   
   
  /////////////////////////////////////////////////////////////////////////////////////////////////////////      
  //Hedge losing trades once the market passes the extremes
   if (OpenTrades > 0 && UseHedging && !HedgingInProgress && BasketUpl < 0)
   {
      if (HasMarketPassedExtreme() )
      {
         HedgePosition();
      }//if (HasMarketPassedExtreme() )   
   }//if (OpenTrades > 0 && UseHedging && !HedgingInProgress && BasketUpl < 0)
  
  /////////////////////////////////////////////////////////////////////////////////////////////////////////      
   
   //Available margin filters
   if (UseScoobsMarginCheck && OpenTrades > 0)
   {
      if(AccountMargin() > (AccountFreeMargin()/100)) 
      {
         Comment("                                     There is insufficient margin to allow trading. You might want to turn off the UseScoobsMarginCheck input.");
         return;
      }//if(AccountMargin() > (AccountFreeMargin()/100)) 
      
   }//if (UseScoobsMarginCheck)


   if (UseForexKiwi && AccountMargin() > 0)
   {
      
      double ml = NormalizeDouble(AccountEquity() / AccountMargin() * 100, 2);
      if (ml < FkMinimumMarginPercent)
      {
         Comment("                                     There is insufficient margin percent to allow trading. " + DoubleToStr(ml, 2) + "%");
         return;
      }//if (ml < FkMinimumMarginPercent)
      
   }//if (UseForexKiwi && AccountMargin() > 0)

   //Swap filter
   TradeDirectionBySwap();
   /////////////////////////////////////////////////////////////////////////////////////////////////////////
if(Debug)Print( "Before LookForTradingOpportunities= "  );
 
   if (UseLimitOrders)
   {
      int Trade = LookForTradingOpportunities();
      if (MathAbs(Trade) == 1 && Send) SendTrade(type,price,lotsize,take, stop);
   }

/////////////////////////////////////////////////////////////////////////////////////////////////////////      

if(Debug)Print("Calculation time is ", GetTickCount()-start, " milliseconds.");
}
//+------------------------------------------------------------------+

